/***************************************************************************
                          sitesurvey.cpp  -  description
                             -------------------
    begin                : Mon Nov 6 2000
    copyright            : (C) 2000 by Jae-Jun Lee
    email                : brucejr@samsung.co.kr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "sitesurvey.h"
#include "swlioctl.h"
#include "iwcommon.h"
SiteSurvey::SiteSurvey(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
}

SiteSurvey::~SiteSurvey(){
}

void SiteSurvey::setDialogWindows(char* name,int skfd1){

   struct iwreq wrq;
   char buf[1000];

  APNum = 0;
  strcpy(ifname,name); //adaptr name,eth0...
  skfd = skfd1;        //socket pointer.
  strcpy(wrq.ifr_name,ifname);

  //start Site Survey...
  wrq.u.data.pointer = (caddr_t)buf;
  wrq.u.data.length = 1;
  wrq.u.data.flags = SWL_UIL_SITESURVEY_START;
  if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
    {
       debug("There is a problem while starting Site Survey...\n");
    }

  //command SCAN RESULT.
  wrq.u.data.pointer = (caddr_t)buf;
  wrq.u.data.length = 1;
  wrq.u.data.flags = SWL_UIL_SCANRESULT;
  if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
    {
       debug("There is a problem while commanding the SCAN RESULT...\n");
   }

//==================================================================================
  Survey_ListView->addColumn("#",20);
  Survey_ListView->addColumn("ESSID",115);
  Survey_ListView->addColumn("Rate(M)",60);
  Survey_ListView->addColumn("Signal(%)",70);
  Survey_ListView->addColumn("Channel",60);
  Survey_ListView->addColumn("BSSID",115);
  Survey_ListView->addColumn("Status",70);

//  new QListViewItem(Survey_ListView,"1","test3","11","90","13","00:00:f0:64:32:74","AP");
//   new QListViewItem(Survey_ListView,"1","test1","11","90","13","00:00:f0:64:32:74","AP");
 // Survey_ListView->InsertItem(temp);
	setCaption("Acces Point In Range...");

  scan_result_Timer = startTimer(500); //1 second
  reset_Timer       = startTimer(5000);
  clear_Timer       = startTimer(30000);
  SCAN_PushButton->setEnabled(false);
  STOP_PushButton->setEnabled(true);

 QObject::connect(SCAN_PushButton,SIGNAL(clicked()),this,SLOT(OnScan()));
 QObject::connect(STOP_PushButton,SIGNAL(clicked()),this,SLOT(OnStop()));
 QObject::connect(CANCEL_PushButton,SIGNAL(clicked()),this,SLOT(OnCancel()));
 QObject::connect(Survey_ListView,SIGNAL( doubleClicked ( QListViewItem * )),
                                                     this,SLOT(OnClickListAP(QListViewItem *)));

}

void SiteSurvey::timerEvent(QTimerEvent* e)
{
	 struct iwreq wrq;
   char buf[1000],*bp;

   bp = buf;
   strcpy(wrq.ifr_name,ifname);

    if(e->timerId() == scan_result_Timer){
       wrq.u.data.pointer = (caddr_t)buf;
       wrq.u.data.length = 1;
       wrq.u.data.flags = SWL_UIL_SCANRESULT;
      if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
       {
        debug("There is a problem to command the SCAN RESULT...\n");
       }
      else
			  retrieveScanResult(buf);
     }
     else if(e->timerId() == reset_Timer){
			  //start Site Survey...
      wrq.u.data.pointer = (caddr_t)buf;
      wrq.u.data.length = 1;
      wrq.u.data.flags = SWL_UIL_SITESURVEY_CONT;
     if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
        {
         debug("There is a problem while continuing the SITE SURVEY...\n");
        }
       }
     else if(e->timerId() == clear_Timer){
       killTimer(scan_result_Timer);
       killTimer(reset_Timer);
       killTimer(clear_Timer);
       SCAN_PushButton->setEnabled(true);
       STOP_PushButton->setEnabled(false);
       }

}

void SiteSurvey::OnScan(){
   struct iwreq wrq;
   char buf[1000];

   APNum = 0;
   Survey_ListView->clear();
   deleteAPList();

   strcpy(wrq.ifr_name,ifname);

   //command SCAN RESULT.
  wrq.u.data.pointer = (caddr_t)buf;
  wrq.u.data.length = 1;
  wrq.u.data.flags = SWL_UIL_SCANRESULT;
  if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
    {
       debug("There is a problem while commanding the SCAN RESULT...\n");
   }

   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = 1;
   wrq.u.data.flags = SWL_UIL_SITESURVEY_CONT;
   if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
        {
         debug("There is a problem while continuing the SITE SURVEY...\n");
        }

   scan_result_Timer = startTimer(1000); //1 second
   reset_Timer       = startTimer(5000);
   clear_Timer       = startTimer(30000);
   SCAN_PushButton->setEnabled(false);
   STOP_PushButton->setEnabled(true);
}
/**  */
void SiteSurvey::OnStop(){

  killTimer(scan_result_Timer);
  killTimer(reset_Timer);
  killTimer(clear_Timer);
  SCAN_PushButton->setEnabled(true);
  STOP_PushButton->setEnabled(false);
}
/**  */
void SiteSurvey::OnCancel(){
   struct iwreq wrq;
   char buf[50];

  killTimer(scan_result_Timer);
  killTimer(reset_Timer);
  killTimer(clear_Timer);

  strcpy(wrq.ifr_name,ifname);
  //end Site Survey...
  wrq.u.data.pointer = (caddr_t)buf;
  wrq.u.data.length = 1;
  wrq.u.data.flags = SWL_UIL_SITESURVEY_END;
  if(ioctl(skfd,SIOCDEVPRIVATE , &wrq) < 0)
    {
       debug("There is a problem while ending Site Survey...\n");
    }

  QDialog::reject();
}
/**  */
void SiteSurvey::retrieveScanResult(char* buf){
  int TotalLen,cnt/*Scan result #*/,i,j;
	char *ptrVal;
	AP_LIST tempList;

	TotalLen = ((buf[1]&0xFF)<<8) + (buf[0]&0xFF);
  //debug("len=%d\n",TotalLen);
	if(TotalLen <=3) return;

  Survey_ListView->clear();

  if((TotalLen/2)>500) TotalLen = 500; //the network driver ONLY supports 1000byte length.
  cnt = (TotalLen -3)/31;
	ptrVal = &(buf[8]);//start point

	for(i=0;i<cnt;++i){
      //ESSID Lenth
	   tempList.essidlen = (ptrVal[17]<<8)+ptrVal[16];
	   if(tempList.essidlen<=0) tempList.essidlen = 0;
	   if(tempList.essidlen>32) tempList.essidlen =32;
	  //ESSID
	   for(j=0;j<tempList.essidlen;++j)
		   tempList.Essid[j] = ptrVal[j+18];
	   tempList.Essid[tempList.essidlen] ='\0';

      //Rate
      tempList.Rate =0;
	  for(j=0;j<6;++j)
	   if(tempList.Rate < (ptrVal[j+50] & 0x7F) )
		     tempList.Rate = (ptrVal[j+50] & 0x7F);//2,4,0x0b,0x16
      if(tempList.Rate != 0) tempList.Rate /= 2;
	  if((tempList.Rate <=0 ) || (tempList.Rate >11)) continue;

      //Signal
	   tempList.Signal = ((ptrVal[5]&0xFF)<<8) + ptrVal[4]&0xFF;
     //debug("signal1 = %d,%d..%d\n",buf[13]&0xFF,buf[12]&0xFF,tempList.Signal);
	  //Channel
	   tempList.Channel = (ptrVal[1]<<8) + ptrVal[0];
	   if((tempList.Channel <=0 ) || (tempList.Channel >14)) continue;
	  //BSSID
	   for(j=0;j<6;++j)
	     tempList.Bssid[j] = ptrVal[j+6];

	  //Status
	   tempList.Status = (ptrVal[15]<<8) + ptrVal[14];

	  //copy into listEntry.
	   insertAPList(&tempList);

	  ptrVal += 62;
	}

	//sort the AP LIST
	SortItem();
	//insert into windows LIST.
  for(i=0;i<APNum;++i) AddItem(i,&listEntry[i]);

}
/**  */
void SiteSurvey::SortItem(){
 	int i,j,k;
	AP_LIST tempList;

	for(i=0;i<APNum;++i)
		for(j=i;j<APNum-1;++j)
			if(listEntry[j].Signal < listEntry[j+1].Signal){

				for(k=0;k<33;++k)
				  tempList.Essid[k] = listEntry[j].Essid[k];
				tempList.Rate    = listEntry[j].Rate;
				tempList.Signal  = listEntry[j].Signal;
				tempList.Channel  = listEntry[j].Channel;
				for(k=0;k<6;++k)
				  tempList.Bssid[k] = listEntry[j].Bssid[k];
				tempList.Status  = listEntry[j].Status;
				tempList.essidlen= listEntry[j].essidlen;

				for(k=0;k<33;++k)
				  listEntry[j].Essid[k] = listEntry[j+1].Essid[k];
				listEntry[j].Rate    = listEntry[j+1].Rate;
				listEntry[j].Signal  = listEntry[j+1].Signal;
				listEntry[j].Channel  = listEntry[j+1].Channel;
				for(k=0;k<6;++k)
				  listEntry[j].Bssid[k] = listEntry[j+1].Bssid[k];
				listEntry[j].Status  = listEntry[j+1].Status;
				listEntry[j].essidlen= listEntry[j+1].essidlen;

				for(k=0;k<33;++k)
				 listEntry[j+1].Essid[k] = tempList.Essid[k];
				listEntry[j+1].Rate = tempList.Rate;
				listEntry[j+1].Signal = tempList.Signal;
				listEntry[j+1].Channel = tempList.Channel;
				for(k=0;k<6;++k)
				 listEntry[j+1].Bssid[k] = tempList.Bssid[k];
				listEntry[j+1].Status = tempList.Status;
				listEntry[j+1].essidlen = tempList.essidlen;
			}
}
/**  */
void SiteSurvey::AddItem(int num, AP_LIST* val){

  char num1[10],essid[33],rate[10],signal[10],channel[10],bssid[50],status[10];
  int wTemp;

  //the number
   sprintf(num1,"%d",num+1);
   //debug("num(%d)=%s\n",num+1,num1);
	//insert ESSID
	 sprintf(essid,"%s",val->Essid);
  // debug("essid=%s\n",essid);
	//insert Rate
	sprintf(rate,"%d",val->Rate);
  //debug("rate(%d)=%s",val->Rate,rate);
  //insert Signal
	
	if(val->Signal != NULL){
		wTemp = ((val->Signal)/15)*10;
		wTemp = wTemp >=100 ? 100 : wTemp;
	}
  else
		wTemp = 0;
	
	sprintf(signal,"%d",wTemp);
  //debug("signal(%d)=%s\n",val->Signal,signal);
  //insert Channel
	sprintf(channel,"%d",val->Channel);
	//debug("channel = %s\n",channel);
  //insert BSSID
	sprintf(bssid,"%02x:%02x:%02x:%02x:%02x:%02x",val->Bssid[0]&0xFF,val->Bssid[1]&0xFF,val->Bssid[2]&0xFF,
				val->Bssid[3]&0xFF,val->Bssid[4]&0xFF,val->Bssid[5]&0xFF);

    //insert Status
	if((val->Status & 0x03) == 0x01) // AP(Infrastructure)
		sprintf(status,"%s","AP");
	else if((val->Status & 0x03) == 0x02) // Station(Ad-hoc)
		sprintf(status,"%s","Station");
	else
		sprintf(status,"%s","Station");

  new QListViewItem(Survey_ListView,num1,essid,rate,signal,channel,bssid,status);

}
/**  */
void SiteSurvey::insertAPList(AP_LIST* tempList){
 	int i,j;

	//duplication check!
	for(i=0;i<20;++i)
      if((listEntry[i].Bssid[0] == tempList->Bssid[0]) &&
		 (listEntry[i].Bssid[1] == tempList->Bssid[1]) &&
		 (listEntry[i].Bssid[2] == tempList->Bssid[2]) &&
		 (listEntry[i].Bssid[3] == tempList->Bssid[3]) &&
		 (listEntry[i].Bssid[4] == tempList->Bssid[4]) &&
		 (listEntry[i].Bssid[5] == tempList->Bssid[5])){
		  // there is a item that have same BSSID and check the signal quality.
		  //if the signal quality is different with two item we will change the old one.
		  if(tempList->Signal != listEntry[i].Signal){
			 for(j=0;j<33;++j) 	
			   listEntry[i].Essid[j] = tempList->Essid[j];
			 listEntry[i].Rate =     tempList->Rate;
			 listEntry[i].Signal =   tempList->Signal;
			 listEntry[i].Channel =  tempList->Channel;
			 listEntry[i].Status =   tempList->Status;
			 listEntry[i].essidlen = tempList->essidlen;
		  }
		    return;
	  }

  for(j=0;j<33;++j)
	   listEntry[APNum].Essid[j] = tempList->Essid[j];
	listEntry[APNum].Rate =     tempList->Rate;
	listEntry[APNum].Signal =   tempList->Signal;
	listEntry[APNum].Channel =  tempList->Channel;
	for(j=0;j<6;++j)
	   listEntry[APNum].Bssid[j] = tempList->Bssid[j];
	listEntry[APNum].Status =   tempList->Status;
	listEntry[APNum].essidlen = tempList->essidlen;

	++APNum;
}
/**  */
void SiteSurvey::deleteAPList(){
   int i,j;

   for(i=0;i<20;++i)
      for(j=0;j<6;++j)
	  listEntry[i].Bssid[j] =0x00;
}
/**  */
void SiteSurvey::OnClickListAP(QListViewItem *item){
  int select;
	char temp[50];
  const char *bp,temp1='0';
  struct iwreq wrq;

  strcpy(wrq.ifr_name, ifname);
  bp = temp;
	bp=item->text(0);
  strcpy(temp,bp);
  select = temp[0] -'0';
  if((temp[1] >='1') && (temp[1]<='9'))
    select = select + (temp[1] -'0')*10;

  --select;
  //debug("select = %d\n",select);

	if((select >=0) && (select <=APNum) && (APNum <20)){
		sprintf(temp,"%s",listEntry[select].Essid);
		
    //essid
    wrq.u.data.pointer = (caddr_t)temp;
    wrq.u.data.length = listEntry[select].essidlen+1;
    wrq.u.data.flags = 1;
    if(ioctl(skfd, SIOCSIWESSID, &wrq) < 0)
      {
         debug("There is a problem while setting ESSID\n");
     }

		if((listEntry[select].Status & 0x03) == 0x01) temp[0] = 1;
        else if((listEntry[select].Status & 0x03) == 0x02) temp[0] = 3;
		else temp[0] =1;
		
    wrq.u.data.pointer = (caddr_t)temp;
    wrq.u.data.length = 1;
    wrq.u.data.flags = SWL_UIL_NETWORKMODE_SET;
    if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) < 0)
    {
      debug("There is a problem while seting NETWORK MODE\n");
    }

    wrq.u.data.pointer = (caddr_t)temp;
    wrq.u.data.length = 1;
    wrq.u.data.flags = SWL_UIL_SOFTRESET;
    if(ioctl(skfd,SIOCDEVPRIVATE, &wrq) < 0)
    {
       debug("There is a problem while SOFT RESET\n");
    }
	}
	
	killTimer(scan_result_Timer);
	killTimer(reset_Timer);
	killTimer(clear_Timer);

	QDialog::accept();
}
