/***************************************************************************
                          wepdlg.h  -  description
                             -------------------
    begin                : Tue Jun 27 2000
    copyright            : (C) 2000 by Jae-Jun Lee
    email                : brucejr@samsung.co.kr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WEPDLG_H
#define WEPDLG_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qgroupbox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>

/**
  *@author Jae-Jun Lee
  */

typedef unsigned long int DWORD;
typedef unsigned short int WORD;
typedef unsigned char BYTE;

typedef struct {
  DWORD state[4];                                   /* state (ABCD) */
  DWORD count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                         /* input buffer */
} MD5_CTX;


class wepDlg : public QDialog  {
   Q_OBJECT
public: 
	wepDlg(QWidget *parent=0, const char *name=0);
	~wepDlg();
	void setDialogWindows(char* name,int skfd1,int wepreq);
  /**  */
  void keyGenerate(char *genstr, unsigned char wep_key[4][5]);
  /**  */
  void keyGenerate128(int len,char* buf,unsigned char* key);

  void MD5Init(MD5_CTX *context);
  void MD5Update(MD5_CTX *context, unsigned char *input, unsigned char inputLen);
  void MD5Final(unsigned char *digest, MD5_CTX *context);
  void MD5Transform(DWORD *state, unsigned char *block);
  void Encode (unsigned char *output, DWORD* input, unsigned int len);
  void Decode (DWORD *output,unsigned char *input,unsigned int len);
  void MD5_memcpy (BYTE* output,BYTE* input,unsigned int len);
  void MD5_memset (BYTE* output, int value,unsigned int len);

protected: 
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QPushButton *OKButton;
	QPushButton *GenerateButton;
	QLineEdit *Key1;
	QLineEdit *Key2;
	QLineEdit *Key3;
	QLineEdit *Key4;
	QComboBox *defaultKeyID;
	QLabel *QLabel_1;
	QLabel *QLabel_11;
	QLabel *QLabel_2;
	QLabel *QLabel_3;
	QLabel *QLabel_4;
	QLabel *QLabel_5;
	QLabel *QLabel_8;
	QLabel *QLabel_7;
	QGroupBox *QGroupBox_1;
	QLineEdit *passphrase;
	QPushButton *WriteButton;
	QPushButton *ClearButton;
	QLabel *QLabel_9;
	QLabel *QLabel_10;
	//Generated area. DO NOT EDIT!!!(end)

private:
public:
     int skfd;
  /**  */
     int wepreq;
     char ifname[10];
     unsigned char wep_key[4][5],key[40];

public slots: // Public slots
  /**  */
  void OnOK();
  /**  */
  void OnGenerate();
  /**  */
  void OnClear();

};

#endif
