/***************************************************************************
                          widgetmain.cpp  -  description
                             -------------------
    begin                : Tue Jun 20 2000
    copyright            : (C) 2000 by Jae-Jun Lee
    email                : brucejr@samsung.co.kr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "widgetmain.h"
#include "configabout.h"
#include "configchange.h"
#include "sitesurvey.h"
#include "swlioctl.h"

#include <qmessagebox.h>
#include <qpen.h>
#include "iwcommon.h"

widgetMain::widgetMain(QWidget *parent, const char *name) : QWidget(parent,name){
	initDialog();
}

widgetMain::~widgetMain(){
}
/**  */
void widgetMain::setupQuit(KApplication *a){

 QObject::connect(SurveyButton,SIGNAL(clicked()),this,SLOT(OnSiteSurvey()));
 QObject::connect(AboutButton,SIGNAL(clicked()),this,SLOT(OnAbout()));
 QObject::connect(ChangeButton,SIGNAL(clicked()),this,SLOT(OnChangeConfig()));

}
/**  */
void widgetMain::OnAbout(){
  configAbout *configAbout_W = new configAbout(0,"Config About");
//  configAbout_W->setGeometry(300,300,500,220);
  configAbout_W->setDialogWindows();
  configAbout_W->setDriverVer(DriverMajor,DriverMinor,DriverVariant);
  configAbout_W->setPRIVer(PRIMajorVersion,PRIMinorVersion,PRIVariant);
  configAbout_W->setSTAVer(STAMajorVersion,STAMinorVersion,STAVariant);

  configAbout_W->exec();
}
/**  */
void widgetMain::setDialogWindows(char* buf){
  struct wireless_info info_str,*info;
  struct iwreq wrq;
  char temp[255];
  QPixmap pm;

  pm.load(KApplication::kde_icondir() + "/sem2.bmp");
  SemLogoLabel->setPixmap(pm);

  ethernet_addr->setFrameStyle(QFrame::Panel | QFrame::Sunken );
  ethernet_addr->setLineWidth( 2 );
  ethernet_addr->setAlignment(AlignLeft);

  NetworkMode->setFrameStyle(QFrame::Panel | QFrame::Sunken );
  NetworkMode->setLineWidth( 2 );
  SSID->setFrameStyle(QFrame::Panel | QFrame::Sunken );
  SSID->setLineWidth( 2 );
  Channel->setFrameStyle(QFrame::Panel | QFrame::Sunken );
  Channel->setLineWidth( 2 );
  Channel->setAlignment(AlignLeft);
  LinkStatus->setFrameStyle(QFrame::Panel | QFrame::Sunken );
  LinkStatus->setLineWidth( 2 );
  LinkStatus->setAlignment(AlignLeft);

// create a channel to the NET kernel.
 skfd = -1;

 if((skfd = sockets_open())<0)
 {
 	 QMessageBox::warning(0,"Warning Messges","There is no SOCKET...\n");
	 exit(-1);
  }
 //else
      //debug("There is a socket..\n");

   info = &info_str;
   strcpy(ifname,buf);

  /* Get wireless name */
//=================================================================================
  strcpy(wrq.ifr_name, ifname);
  if(ioctl(skfd, SIOCGIWNAME, &wrq) < 0){
      strcpy(ifname,"eth1");
      strcpy(wrq.ifr_name, ifname);

      if(ioctl(skfd, SIOCGIWNAME, &wrq) < 0){
          strcpy(ifname,"eth2");
          strcpy(wrq.ifr_name, ifname);
          if(ioctl(skfd, SIOCGIWNAME, &wrq) < 0){
             debug("No wireless extensions\n");
             QMessageBox::warning(this,"WARNING!","There is no SAMSUNG 11Mbps WLAN Card!.\n"
                                            "Please insert the Card!","OK",0,0);
             OnExit();
 		}
		else
 		  strcpy(info->name, wrq.u.name);	
       }
      else{
          strcpy(info->name, wrq.u.name);
        }
     }
  else
    strcpy(info->name, wrq.u.name);

  if(strcmp(info->name,"SAMSUNG WLAN")<0){
    QMessageBox::warning(this,"WARNING!","There is no SAMSUNG 11Mbps WLAN Card!.\n"
    								 "Please insert the Card!","OK",0,0);
    OnExit();
    }
//==================================================================================
  strcpy(temp,"11Mbps Wireless LAN Card (");
  strcat(temp,ifname);
  strcat(temp,")");
  CardName->setText(temp);
  getInitialStatus();  	

}
/**  */
int widgetMain::sockets_open(void){
	int ipx_sock = -1;		/* IPX socket			*/
	int ax25_sock = -1;		/* AX.25 socket			*/
	int inet_sock = -1;		/* INET socket			*/
	int ddp_sock = -1;		/* Appletalk DDP socket		*/

	inet_sock=socket(AF_INET, SOCK_DGRAM, 0);
	ipx_sock=socket(AF_IPX, SOCK_DGRAM, 0);
	ax25_sock=socket(AF_AX25, SOCK_DGRAM, 0);
	ddp_sock=socket(AF_APPLETALK, SOCK_DGRAM, 0);
	/*
	 * Now pick any (exisiting) useful socket family for generic queries
	 */
	if(inet_sock!=-1){
	     //debug("It is a INET_SOCK..\n");
		return inet_sock;
		}
	if(ipx_sock!=-1){
		//debug("It is a IPX_SOCK..\n");
		return ipx_sock;
		}
	if(ax25_sock!=-1){
	  	//debug("It is a AX25_SOCK..\n");
		return ax25_sock;
		}
	/*
	 * If this is -1 we have no known network layers and its time to jump.
	 */
	
	return ddp_sock;
}
/**  */
void widgetMain::OnExit(){
  close(skfd);
  exit(-1);
}
/**  */
void widgetMain::getInitialStatus(){
  struct wireless_info info_str,*info;
  struct iwreq wrq;
  char buf[256],*bp;
  int temp1,temp2;
	
  bp = buf;
  info = &info_str;
  memset((char*)info, 0, sizeof(struct wireless_info));

    // Get frequency / channel

  strcpy(wrq.ifr_name, ifname);
  if(ioctl(skfd, SIOCGIWFREQ, &wrq) >= 0)
    {
      info->has_freq = 1;
      info->freq = wrq.u.freq.m;
      channel = (int)info->freq;
    }
//    debug("Channel = %d\n",channel);

  // Get ESSID
  strcpy(wrq.ifr_name, ifname);
  wrq.u.data.pointer = (caddr_t) essid;
  wrq.u.data.length = 0;
  wrq.u.data.flags = 0;
  if(ioctl(skfd, SIOCGIWESSID, &wrq) >= 0)
    {

//       debug("ESSID = %s\n",essid);
    }


  // Get bit rate
//  strcpy(wrq.ifr_name, ifname);
//  if(ioctl(skfd, SIOCGIWRATE, &wrq) >= 0)
//    {
//      info->has_bitrate = 1;
//      info->bitrate_fixed = wrq.u.bitrate.fixed;
//      info->bitrate = wrq.u.bitrate.value;
//      debug("Tx Rate = %ld Mbps\n",info->bitrate/1000000);
//    }

  //Get the Network Mode Value
  strcpy(wrq.ifr_name, ifname);
  wrq.u.data.pointer = (caddr_t)buf;
  wrq.u.data.length = 0;
  wrq.u.data.flags = SWL_UIL_NETWORKMODE_GET;
  if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
    {
//      debug("NetworkMode = %d\n",(int)buf[0]);
      NetworkModeValue = (int)buf[0];
      if(NetworkModeValue == 1)
         NetworkMode->setText("Infrastructure");
      else if(NetworkModeValue == 3)
         NetworkMode->setText("Ad-hoc");

    }
  else{
      debug("private ioctl failed..\n");
      NetworkModeValue = 1; //default as infrastructure...
  }

  //Get the Version(SWL_UIL_VER).
  //1st byte = DriverMajor, 2st = DriverMinor, 3st = Primary F/W Major,4st = Primary F/W Minor,
  //5st = Primary F/W Variant,6st = Secondary F/W Major,7st = Secondary F/W Minor, 8st = Secondary F/W Variant.
   strcpy(wrq.ifr_name, ifname);
   wrq.u.data.pointer = (caddr_t)buf;
   wrq.u.data.length = 0;
   wrq.u.data.flags = SWL_UIL_VER;
   if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
    {
//      debug("Driver = %d.%d, Primary F/W=%d.%d%d, Secondary F/w=%d.%d%d\n",buf[0],
//           buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
      DriverMajor     = buf[0]; DriverMinor    = buf[1],DriverVariant = buf[2];
      PRIMajorVersion = buf[3];PRIMinorVersion = buf[4];PRIVariant = buf[5];
      STAMajorVersion = buf[6];STAMinorVersion = buf[7];STAVariant = buf[8];
    }
   //Link Status(SWL_UIL_LINKSTATUS).
     strcpy(wrq.ifr_name, ifname);
     wrq.u.data.pointer = (caddr_t)buf;
     wrq.u.data.length = 0;
     wrq.u.data.flags = SWL_UIL_LINKSTATUS;
     if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
     {
//      debug("LINK STATUS = %d\n",buf[0]);
      LinkStatusValue = buf[0];
    }

    //Link Status(SWL_UIL_COMMSQUALITY).
     strcpy(wrq.ifr_name, ifname);
     wrq.u.data.pointer = (caddr_t)buf;
     wrq.u.data.length = 0;
     wrq.u.data.flags = SWL_UIL_COMMSQUALITY;
     if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
     {
      CQ = ((buf[1]&0xFF)<<8) + (buf[0]&0xFF);
      SL = ((buf[3]&0xFF)<<8) + (buf[2]&0xFF);

      temp1 =(CQ*4)/3;
      temp1 = temp1>=100 ? 100 : temp1;
      temp2 =(SL*4)/3;
      temp2 = temp2>=100 ? 100 : temp2;
     // temp3 =(NL*4)/3;
     // temp3 = temp3>=100 ? 100 : temp3;
      LinkQualityProgress->setProgress(temp1);
  	 SignalLevelProgress->setProgress(temp2);
  	 //NoiseLevelProgress->setProgress(temp3);
  	 //debug("CQ= %d(%d),SL=%d(%d)\n",CQ,temp1,SL,temp2);
    }

    if(temp1>=40)
      ConnectionButton->setText("Excellent");
    else if(temp1>=25)
      ConnectionButton->setText("Good");
    else
      ConnectionButton->setText("Poor");
  //Get Current Station MAC Address(SWL_UIL_CURRENT_ADDRESS).
    strcpy(wrq.ifr_name, ifname);
    wrq.u.data.pointer = (caddr_t)buf;
    wrq.u.data.length = 0;
    wrq.u.data.flags = SWL_UIL_CURRENT_ADDRESS;
    if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
    {
      char addr_buf[20];
      sprintf(addr_buf,"%02x:%02x:%02x:%02x:%02x:%02x\n",buf[0] &0xFF,
           buf[1]&0xFF,buf[2]&0xFF,buf[3]&0xFF,buf[4]&0xFF,buf[5]&0xFF);
      //debug("%s",addr_buf);
      ethernet_addr->setText(addr_buf);
    }

  // Get AP address
  strcpy(wrq.ifr_name, ifname);
  if(ioctl(skfd,SIOCGIWAP, &wrq) >= 0)
    {

	 sprintf(ap_addr,"%02x%02x%02x%02x%02x%02x\n",wrq.u.ap_addr.sa_data[0] & 0xFF,wrq.u.ap_addr.sa_data[1] & 0xFF,wrq.u.ap_addr.sa_data[2] & 0xFF,
	    wrq.u.ap_addr.sa_data[3] & 0xFF,wrq.u.ap_addr.sa_data[4] & 0xFF,wrq.u.ap_addr.sa_data[5] & 0xFF);
    }	

// update vlues into dialog box.
  SSID->setText(essid);

  sprintf(bp,"%d\n",channel);
  Channel->setText(buf);

  if(NetworkModeValue == 1){ //infrastructure
    strcpy(buf,"Current BSSID :");
    strcat(buf,ap_addr);
    LinkStatus->setText(buf);
   }
   else{
    strcpy(buf,"IBSS Connected...");
    LinkStatus->setText(buf);
    LinkQualityProgress->setProgress(90);
    SignalLevelProgress->setProgress(90);
//    NoiseLevelProgress->setProgress(5);
   }

  mainDlgTimer1 = startTimer(2000);
}
/**  */
void widgetMain::OnChangeConfig(){

//  QMessageBox::information(this,"OnChangeConfig","OnConfigChange start...\n");
  configChange *configchange = new configChange(0,"Change Configuration");

//  configchange->setGeometry(250,250,350,260);
  configchange->setDialogWindows(ifname,skfd,NetworkModeValue,channel);

  killTimer(mainDlgTimer1);
  configchange->exec();
//  if(ret == QDialog::Accepted)
   // debug("user pressed OK Button \n");
//  else
   // debug("user pressed Cancel\n");
   mainDlgTimer1 = startTimer(2000);
   getInitialStatus();  	

}
/**  */
void widgetMain::timerEvent(QTimerEvent* e){
  struct wireless_info info_str,*info;
  struct iwreq wrq;
  char buf[256],*bp;
  int temp1,temp2;

  bp = buf;
  info = &info_str;
  memset((char*)info, 0, sizeof(struct wireless_info));

 // debug("timer...\n");
  if(NetworkModeValue != 3){//do something if only infrastructure...
  //Link Status(SWL_UIL_LINKSTATUS).
     strcpy(wrq.ifr_name, ifname);
     wrq.u.data.pointer = (caddr_t)buf;
     wrq.u.data.length = 0;
     wrq.u.data.flags = SWL_UIL_LINKSTATUS;
     if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
     {
 //     debug("LINK STATUS = %d\n",buf[0]);
      }
     LinkStatusValue = buf[0];

     switch(LinkStatusValue){
      case LINK_CONNECTED:
      case LINK_AP_IN_RANGE:
      case LINK_AP_CHANGE:
            //check if there are any values changed.
            //if then request soem IOCTL to get the current values.
         if((NetworkModeValue  == 1)){
            // Get AP address
 		     strcpy(wrq.ifr_name, ifname);
		     if(ioctl(skfd,SIOCGIWAP, &wrq) >= 0)
		        {
 	           sprintf(ap_addr,"%02x%02x%02x%02x%02x%02x\n",wrq.u.ap_addr.sa_data[0] & 0xFF,wrq.u.ap_addr.sa_data[1] & 0xFF,wrq.u.ap_addr.sa_data[2] & 0xFF,
   	           wrq.u.ap_addr.sa_data[3] & 0xFF,wrq.u.ap_addr.sa_data[4] & 0xFF,wrq.u.ap_addr.sa_data[5] & 0xFF);
                strcpy(buf,"Current BSSID :");
		      strcat(buf,ap_addr);
		      LinkStatus->setText(buf);
		     }
          // Get ESSID
				 wrq.u.data.pointer = (caddr_t) essid;
			   wrq.u.data.length = 0;
			   wrq.u.data.flags = 0;
			  if(ioctl(skfd, SIOCGIWESSID, &wrq) >= 0)
    			{
					//       debug("ESSID = %s\n",essid);
          SSID->setText(essid);
			    }

		     // Get frequency / channel
		    strcpy(wrq.ifr_name, ifname);
		    if(ioctl(skfd, SIOCGIWFREQ, &wrq) >= 0)
	       {
	      	info->has_freq =1;
	     	 info->freq = wrq.u.freq.m;
		     channel = (int)info->freq;
		     sprintf(bp,"%d\n",channel);
		     Channel->setText(buf);
    		 }
    		}// if((NetworkModeValue  == 1) && (APChanged == 1)){
    		
           break;

      case LINK_NOT_CONNECTED:
      case LINK_DISCONNECTED:
           LinkStatus->setText("Searching...");
           break;
//      case LINK_AP_CHANGE:
//           LinkStatus->setText("AP Changed...");
//           break;
      case LINK_AP_OUTOF_RANGE:
      	 LinkStatus->setText("Out Of Range...");
           break;
      case LINK_ASSOCIATION_FAILED:
           LinkStatus->setText("Association failed...");
           break;
      default:
      	 LinkStatus->setText("Searching...");
           break;
    }

    //Link Status(SWL_UIL_COMMSQUALITY).
     strcpy(wrq.ifr_name, ifname);
     wrq.u.data.pointer = (caddr_t)buf;
     wrq.u.data.length = 0;
     wrq.u.data.flags = SWL_UIL_COMMSQUALITY;
     if(ioctl(skfd, SIOCDEVPRIVATE, &wrq) >= 0)
     {
      CQ = ((buf[1]&0xFF)<<8) + (buf[0]&0xFF);
      SL = ((buf[3]&0xFF)<<8) + (buf[2]&0xFF);

      temp1 =(CQ*4)/3 + 10;
      temp1 = temp1>=100 ? 100 : temp1;
      temp2 =(SL*4)/3;
      temp2 = temp2>=100 ? 100 : temp2;
     // temp3 =(NL*4)/3;
     // temp3 = temp3>=100 ? 100 : temp3;
      LinkQualityProgress->reset();
      LinkQualityProgress->setProgress(temp1);
      SignalLevelProgress->reset();
  	 SignalLevelProgress->setProgress(temp2);
  	 //NoiseLevelProgress->reset();
  	 //NoiseLevelProgress->setProgress(temp3);
  	// debug("CQ= %d(%d),SL=%d(%d)\n",CQ,temp1,SL,temp2);
     }
     if(temp1>=40)
      ConnectionButton->setText("Excellent");
     else if(temp1>=25)
      ConnectionButton->setText("Good");
     else
      ConnectionButton->setText("Poor");
      	
    }
}

/**  */
void widgetMain::OnSiteSurvey(){
  int ret;
  SiteSurvey *configSurvey = new SiteSurvey(0,"SiteSurvey");

  if(STAMajorVersion<=0){
    if(STAMinorVersion < 0x07)
      QMessageBox::warning(this,"WARNING!","This firmware does not support this function!\n"
             "Please upgrade your firmware into the latest!","OK",0,0);
    else if((STAMinorVersion <= 0x07) && (STAVariant<0x05))
      QMessageBox::warning(this,"WARNING!","This firmware does not support this function!\n"
             "Please upgrade your firmware into the latest!","OK",0,0);
  }

  configSurvey->setDialogWindows(ifname,skfd);

  killTimer(mainDlgTimer1);
  ret = configSurvey->exec();

//  if(ret == QDialog::Accepted){
    //debug("selected one AP... \n");
    getInitialStatus();
//   }
//  else
    //debug("user pressed Cancel\n");

  mainDlgTimer1 = startTimer(2000);

}