/***************************************************************************
                          widgetmain.h  -  description
                             -------------------
    begin                : Tue Jun 20 2000
    copyright            : (C) 2000 by Jae-Jun Lee
    email                : brucejr@samsung.co.kr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WIDGETMAIN_H
#define WIDGETMAIN_H
#include <kapp.h>

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qprogressbar.h>
//Generated area. DO NOT EDIT!!!(end)


/**
  *@author Jae-Jun Lee
  */

class widgetMain : public QWidget  {
   Q_OBJECT
public: 
	widgetMain(QWidget *parent=0, const char *name=0);
	~widgetMain();
  /**  */
  /**  */
  void setDialogWindows(char* buf);
  void setupQuit(KApplication *a);
  /**  */
  int sockets_open(void);
  /**  */
  void getInitialStatus();
  /**  */
  void timerEvent(QTimerEvent* e);

protected: 
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QLabel *CardName;
	QPushButton *AboutButton;
	QPushButton *ChangeButton;
	QPushButton *SurveyButton;
	QLabel *ethernet_addr;
	QLabel *NetworkModeLabel;
	QLabel *SSID;
	QLabel *ChannelLabel;
	QGroupBox *QGroupBox_2;
	QLabel *LinkStatusLabel;
	QLabel *SignalLabel;
	QLabel *ConnectionLabel;
	QPushButton *ConnectionButton;
	QProgressBar *SignalLevelProgress;
	QProgressBar *LinkQualityProgress;
	QLabel *QualityLabel;
	QLabel *NetworkMode;
	QLabel *Channel;
	QLabel *SemLogoLabel;
	QLabel *MACIDLabel;
	QLabel *SSIDLabel;
	QLabel *LinkStatus;
	//Generated area. DO NOT EDIT!!!(end)

private: 
public slots: // Public slots
  /**  */
  void OnAbout();
  /**  */
  void OnExit();
  /**  */
  void OnChangeConfig();
  void OnSiteSurvey();
public: // Public attributes
  /**  */
  int skfd;  //generic raw socket desc.
  /**  */
  int channel;
  /**  */
  char ap_addr[20];
  /**  */
  char ifname[10];
  /**  */
  int NetworkModeValue;
  /** driver minor version */
  int DriverMinor;
  /** driver major version */
  int DriverMajor;
  int DriverVariant;
  /**  */
  int STAVariant;
  /**  */
  int STAMinorVersion;
  /** secondary Major Version */
  int STAMajorVersion;
  /**  */
  int PRIVariant;
  /** primary f/w minor version */
  int PRIMinorVersion;
  /** Primary F/W major version */
  int PRIMajorVersion;
  /**Link Status Value  */
  int LinkStatusValue;
  /** Noise Level */
//  int NL;
  /** Siganl Level */
  int SL;
  /** Communication Quality */
  int CQ;
  /**  */
  int mainDlgTimer1;
  /**  */
  char essid[33];

};

#endif
